unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Memo1: TMemo;
    Edit5: TEdit;
    Button1: TButton;
    Edit6: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
var
  Switch:Integer;
{ Switch       1  4  }
{      }
{       " "        }

function GetCodeName(V : Variant): String;
{      }
type
  TypeCodeNames = array [$0000..$000D] of String;
const
  CodeNames: TypeCodeNames =
       ('varEmpty','varNull','varSmallint','varInteger', 'varSingle','varDouble',
        'varCurrency','varDate', 'varOleStr','varDispatch','varError','varBoolean',
        'varVariant','varUnknown');
var
  Code : Integer;
begin
  Code := VarType(V) and varTypeMask;
  case Code of
    $0000..$000D: Result:= CodeNames[Code];
           $0011: Result:='varByte';
           $0100: Result:='varString';
           $0FFF: Result:='varTypeMask';
           $2000: Result:='varArray';
    else Result :='varError';
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  Op1, Op2 : Variant;
  Integer1,Integer2 : Integer;
  Double1, Double2 : Double;
  Currency1, Currency2 : Currency;
  TDateTime1, TDateTime2 : TDateTime;

procedure PrintOperands (Op1, Op2: Variant);
{      }
{        }
{  Edit1, Edit2, Edit3  Edit4.}
var
  CodeName, S : String;
begin
  CodeName := GetCodeName(Op1);
  Edit1.Text := CodeName;
  if CodeName <> 'varString' then Str(Op1:10:4, S)
  else S := Op1;
  Edit2.Text := S;
  CodeName := GetCodeName(Op2);
  Edit3.Text := CodeName;
  if CodeName <> 'varString' then Str(Op2:10:4, S)
  else S := Op2;
  Edit4.Text := S;
end;

procedure Action1 (Op1,Op2: Variant);
{ Actionl              }
{Memol,             }
{  Opl   O2     ,        }
{     .             }
{   EVariantError             }
{     .             }
{     "               }
{  ".                                           }
var
  Res : Variant;
  S   : String;
begin
  try
    {       Memol. }
    Memo1.Lines[0]:='try';
    Memo1.Lines[1]:='   Res := Op1 + 0p2;';
    Memo1.Lines[2]:='   Str (Res:10:4, S);';
    Memo1.Lines[3]:='   MessageDlg(''Op1 + Op2 = ''+S, '+
        'mtlnformation,[mbOk],0) ; ' ;
    Memo1.Lines[4]:='   Res := Op1 / Op2;';
    Memo1.Lines[5]:='   Str (Res:10:4, S);';
    Memo1.Lines[6]:='   MessageDlg(''Op1 / Op2 = ''+S, ' +
        'mtlnformation,[mbOk],0) ; ' ;
    Memo1.Lines[7]:='except';
    Memo1.Lines[8]:='   on  EVariantError do';
    Memo1.Lines[9]:='  MessageDlg('' EVariantError'', '+
        'mtError,[mbOk],0);';
    Memo1.Lines[10]:='  else';
    Memo1.Lines[11]:='  MessageDlg(''  '+
        ''' , mtError, [mbOK] , 0); ' ;
    Memo1.Lines[12]:='end;';
    Edit6.Text:='+';
    Res := Op1 + Op2;
    Str (Res:10:4, S);
    MessageDlg('Op1 + Op2 = '+S, mtInformation,[mbOk],0);
    Edit6.Text:='/';
    Res := Op1 / Op2;
    Str (Res:10:4, S);
    MessageDlg('Op1 / Op2 = '+S, mtInformation,[mbOk],0);
  except
    on EVariantError do
        MessageDlg(' EVariantError', mtError,[mbOk],0);
  else
        MessageDlg('  ', mtError,[mbOk],0);
  end;
end;

procedure Action2 (Op1,Op2: Variant);
{   Actionl,      -     }
{               }
{   "-     ".            }
var
  Res : Variant;
  S   : String;
begin
  try
    {       Memol. }
    Memo1.Lines[0]:='try';
    Memo1.Lines[1]:='   Res := Op1 + 0p2;';
    Memo1.Lines[2]:='   Str (Res:10:4, S);';
    Memo1.Lines[3]:='   MessageDlg(''Op1 + Op2 = ''+S, '+
        'mtlnformation,[mbOk],0) ; ' ;
    Memo1.Lines[4]:='   Res := Op1 / Op2;';
    Memo1.Lines[5]:='   Str (Res:10:4, S);';
    Memo1.Lines[6]:='   MessageDlg(''Op1 / Op2 = ''+S, ' +
        'mtlnformation,[mbOk],0) ; ' ;
    Memo1.Lines[7]:='except';
    Memo1.Lines[8]:='  MessageDlg(''-   '+
        ''' , mtError, [mbOK] , 0); ' ;
    Memo1.Lines[9]:='end;';
    Edit6.Text:='+';
    Res := Op1 + Op2;
    Str (Res:10:4, S);
    MessageDlg('Op1 + Op2 = '+S, mtInformation,[mbOk],0);
    Edit6.Text:='/';
    Res := Op1 / Op2;
    Str (Res:10:4, S);
    MessageDlg('Op1 / Op2 = '+S, mtInformation,[mbOk],0);
  except
    MessageDlg('-   ', mtError,[mbOk],0);
  end;
end;

procedure Action3 (Op1,Op2: Variant);
{    Action2,  - }
{         }
{try. . . finally.  "    }
{finally"           }
{ ,     	  }
{ .                                 }
var
  Res : Variant;
  S   : String;
begin
  try
    {       Memol. }
    Memo1.Lines[0]:='try';
    Memo1.Lines[1]:='   Res := Op1 / Op2;';
    Memo1.Lines[2]:='   Str (Res:10:4, S);';
    Memo1.Lines[3]:='   MessageDlg(''Opl / Op2 = ''+S, ' +
        'mtlnformation,[mbOk],0) ; ' ;
    Memo1.Lines[4]:='finally';
    Memo1.Lines[5]:='  MessageDlg(''   '+
        'finally'' , mtInformation, [mbOK] , 0); ' ;
    Memo1.Lines[6]:='end;';
    Edit6.Text:='/';
    Res := Op1 / Op2;
    Str (Res:10:4, S);
    MessageDlg('Opl / Op2 = '+S, mtInformation,[mbOk],0);
  finally
    MessageDlg('   finally', mtInformation,[mbOk],0);
  end;
end;

procedure Action4 (Op1,Op2: Variant);
{    Action2,  -   }
{       }
{ try try ... except ... end; finally ... end.        }
{  "   finally"       }
{      ,    }
{           }
{  .                                         }
var
  Res : Variant;
  S   : String;
begin
  try
   try
    {       Memol. }
    Memo1.Lines[0]:='try';
    Memo1.Lines[1]:=' try';
    Memo1.Lines[2]:='   Res := Op1 / Op2;';
    Memo1.Lines[3]:='   Str (Res:10:4, S);';
    Memo1.Lines[4]:='   MessageDlg(''Op1 / Op2 = ''+S, ' +
        'mtlnformation,[mbOk],0) ; ' ;
    Memo1.Lines[5]:='except';
    Memo1.Lines[6]:='  MessageDlg(''-   '+
        ''' , mtError, [mbOK] , 0); ' ;
    Memo1.Lines[7]:='end;';
    Memo1.Lines[8]:='finally';
    Memo1.Lines[9]:='  MessageDlg(''   '+
        'finally'' , mtInformation, [mbOK] , 0); ' ;
    Memo1.Lines[10]:='end;';
    Edit6.Text:='/';
    Res := Op1 / Op2;
    Str (Res:10:4, S);
    MessageDlg('Op1 / Op2 = '+S, mtInformation,[mbOk],0);
  except
    MessageDlg('-   ', mtError,[mbOk],0);
  end;
  finally
    MessageDlg('   finally', mtInformation,[mbOk],0);
  end;
end;
begin {TForm1.Button1Click}
  case Switch of
    1: begin
         Inc(Switch);
         Form1.Caption := ' try. ..except on...do...else...end';
         {      . }
         Edit5.Text:= ' try...except on...do...else...end,'+
                 '    ';
         Op1 := 4; Op2 := 2;
         PrintOperands (Op1, Op2);
         Action1(Op1, Op2);
         {       EVariantError. }
         Edit5.Text:=' try...except on...do...else...end,'+
             '    EVariantError';
         Op1 := 4; Op2 := 'A';
         PrintOperands (Op1, Op2);
         Action1(Op1, Op2);
         {        }
         { (  ). }
         Edit5.Text:=' try...except on...do...else...end,' +
                   '     ';
         Op1 := 4; Op2 := 0;
         PrintOperands (Op1, Op2);
         Action1(Op1, Op2);
       end;
    2: begin
         Inc(Switch);
         Form1.Caption :=' try...except...end';
         {      . }
         Edit5.Text:=' try...except...end,'+
                  '    ';
         Op1 := 4; Op2 := 2;
         PrintOperands (Op1, Op2); Action2(Op1, Op2);
         {       EVariantError. }
         Edit5.Text:=' try...except...end,'+
                     '    EVariantError';
         Op1 := 4; Op2 := 'A';
         PrintOperands (Op1, Op2); Action2(Op1, Op2);
         {        }
         { (  ). }
         Edit5.Text:=' try...except...end,'+
                 '     ';
         Op1 := 4; Op2 := 0;
         PrintOperands (Op1, Op2); Action2(Op1, Op2);
       end;
    3: begin
         Inc(Switch);
         Form1.Caption :=' try...finally...end';
         {      . }
         Edit5.Text:=' try...finally...end,'+
                  '    ';
         Op1 := 4; Op2 := 2;
         PrintOperands (Op1, Op2); Action3(Op1, Op2);
         {       (  ). }
         Edit5.Text:=' try...finally...end,'+
                     '   - ';
         Op1 := 4; Op2 := 0;
         PrintOperands (Op1, Op2); Action3(Op1, Op2);
       end;
    4: begin
         Switch:=1;
         Form1.Caption :=' try try...except...end; finally... end';
         {      . }
         Edit5.Text:= ' try try. ..except...end;' +
                 ' finally...end,    ';
         Op1 := 4; Op2 := 2;
         PrintOperands (Op1, Op2); Action4(Op1, Op2);
         {       (  ). }
         Edit5.Text:= ' try try...except...end; ' +
              'finally...end,   - ';
         Op1 := 4; Op2 := 0;
         PrintOperands (Op1, Op2); Action4(Op1, Op2);
       end;
  end; {case}
end; {TForm1.Button1Click}

procedure TForm1.FormCreate(Sender: TObject);
var
  i:Byte;
begin
   for i:=0 to 12 do Memo1.Lines.Add(' ');
   Form1.Caption := ' try' ;
end;

initialization
    Switch:=1;

end.
